/**
*U-File Explorer App
* Defined an App to manage openufileexplorer
*/
var UFileExplorerApp = UFileExplorerApp || {};  //Define OpenU-File Explorer App namespace.
/**
*Constructor UNAS App
*/
var ufile_username = jQuery('#unas-desktop_current_user').text();

UFileExplorerApp.App = function () {
    this.id = 'U-File Explorer';
    this.name = 'U-File Explorer';
    this.version = '6.0.120';
    this.active = false;
    this.menuIcon = '/apps/ufileexplorer/images/logo.png';
    this.shortcutIcon = '/apps/ufileexplorer/images/logo.png';
    var self = this;
    this.UFileExplorerAppWindow = function () {
        UFileExplorerAppWindowID = 'UFileExplorerAppWindow' + Date.now();
    	if(UNAS.CheckAppState('U-File Explorer')) {
    		return false;
        }
        function UFileExplorerKeepAlive(){
            jQuery.ajax({
                url: "/wmi/",
                type: "POST",
                async: true,
                dataType: "json",
                data: JSON.stringify({
                  "token": UToken,
                  "cmd": 'user_renewal'
                }),
                timeout: 20000,
                complete: function(){
                    var FileExplorerWindow = window.top.UNAS.GetWindow(UFileExplorerAppWindowID);
                    if (FileExplorerWindow) {
                        setTimeout(function() {
                            UFileExplorerKeepAlive();
                        }, 10000);
                    }
                }
            });
        }

        UFileExplorerKeepAlive();
        self.window=new MUI.Window({
            id: UFileExplorerAppWindowID,
            title: UNAS._('U-File Explorer'),
            icon: '/apps/ufileexplorer/images/logo_small.png',
            loadMethod: 'iframe',
            width: 1300,
            height: 600,
            maximizable: false,
            resizable: true,
            scrollbars: false,
            resizeLimit: { 'x': [1070, 2000], 'y': [500, 1500] },
            contentURL: '/apps/ufileexplorer/index.html',
        });
    };
    this.UFileExplorerUninstall = function (){
    	UNAS.RemoveDesktopShortcut('U-File Explorer');
    	UNAS.RemoveMenu('U-File Explorer');
    	UNAS.RemoveAppFromGroups('U-File Explorer', 'ControlPanel');
    	UNAS.RemoveAppFromApps('U-File Explorer');
    };
    //new UNAS.Menu('UNAS_App_Internet_Menu', this.name, this.menuIcon, 'U-File Explorer', '', this.UFileExplorerAppWindow);
   	new UNAS.DesktopShortcut(this.name, this.shortcutIcon, 'U-File Explorer', this.UFileExplorerAppWindow);
    //new UNAS.RegisterToAppGroup(this.name, 'ControlPanel', {'Type' : 'Internet', 'Location' : 1, "Icon": this.shortcutIcon, "Url": this.entryUrl}, {});
    var OnChangeLanguage = function (e) {
    	//UNAS.SetMenuTitle('U-File Explorer', UNAS._('U-File Explorer')); //translate menu
        UNAS.SetShortcutTitle('U-File Explorer', UNAS._('U-File Explorer'));
        if (typeof self.window !== 'undefined') {
        	UNAS.SetWindowTitle(UFileExplorerAppWindowID, UNAS._('U-File Explorer'));
        }
    };
    UNAS.LoadTranslation('/apps/ufileexplorer/languages/Translation?v=' + this.version, OnChangeLanguage);
    UNAS.Event.addEvent('ChangeLanguage', OnChangeLanguage);
	UNAS.CreateApp(this.name, this.shortcutIcon, this.UFileExplorerAppWindow, this.UFileExplorerUninstall);
};

new UFileExplorerApp.App();
