(function (event) {
    let FileUploadDP = { //默认参数
        //ClickElement: null, //单击元素
        DragElement: null, //拖拽元素
        OPPattern: null, //操作模式
        ReturnButtom: null, //返回元素
        QuantityLimit: 1024, //数量限制
        //ConsoleAutograph: true, //是否开启版权提示
        OutputWarning: true, //是否输出警告
        FormatList: ['apng', 'svg+xml', 'avif', 'bmp', 'gif', 'ico', 'cur', 'jpg', 'jpeg', 'jfif', 'pjpeg',
            'pjp', 'png',
            'svg', 'tif', 'tiff', 'webp', 'ogg', 'mp3', 'wav', 'flac', 'mpeg', 'mp4', 'webm', 'avi', 'ogv'
        ],
        OPState: function (OPState) {
            //console.log("OPState:" + OPState);
        }, //操作状态
        ResultSet: function (ResultSet) {
            //console.log(ResultSet);
        } //操作结果
    };

    let ClearSetTimeout = null;
    let DropFormCheck = true; //格式不检查
    let DropFileFirstFlag = false;

    function TemporaryListObject(data) {

    }

    let TemporaryList = new TemporaryListObject(null);

    function ErrorListObject(data) {

    }

    let ErrorList = new ErrorListObject(null);

    function ResultObject(data) {

        //创建常用键值对
        this.ResultType = null;
        this.UploadList = new Object();
        this.AttributeList = new Object();
        this.AttributeArray = new Array();
        this.ErrorList = new Object();
    }

    let getResult = new ResultObject(null);

    //用于判断是否点击过“提交”一类按钮
    let Whether = false;

    //文件上传类
    class FileUploadClass {
        constructor(data) {
            if (!navigator.onLine) {
                console.warn('设备未联网，可能发生操作失败');
            }
            if (!window.location.protocol || window.location.protocol === 'file:') {
                throw new Error('网络协议不正确，至少为http协议');
            }

        }

        // 初始化
        init(options) {
            //将this赋值给ClassThis，以便后续调用，防止与其他的this混淆
            //class的函数（第一层）调用是没问题的，因为它们的this就是class的this
            //但它们中的函数调用就不一定行了，因为this不一定是class的this
            const ClassThis = this;

            //将接收的参数赋值给this.options
            this.options = Object.assign({}, FileUploadDP, options);

            //返回状态码
            this.options.OPState(0);

            //判断是否开启版权提示
            if (this.options.ConsoleAutograph === true) {

            }

            //获取单击元素
            //this.CElement = document.querySelector(this.options.ClickElement);

            //获取拖拽元素
            this.DElement = document.querySelector(this.options.DragElement);

            //获取返回按钮元素
            //this.ReturnButtom = document.querySelector(this.options.ReturnButtom);

            //判断元素是否存在
            //this.ReturnButtom = this.ReturnButtom ? this.ReturnButtom : false;


            //调用拖拽提交函数
            if (this.options.OPPattern === 'drag' || this.options.OPPattern === 'dragandclick') {
                // 判断元素是否存在
                if (this.options.DragElement) {
                    //调用设置穿透函数

                }
                this.DElementFun(ClassThis);
            }

            //输出警告函数
            this.init.OutputWarning = function (ClassThis, OutputWarning) {
                if (ClassThis.options.OutputWarning === true) {
                    console.warn(OutputWarning);
                }
            }
        }



        DElementFun(ClassThis) {
            // 在元素正在拖动到放置目标时触发,//不能注释，否则文件无论如何都会打开
            ClassThis.DElement.addEventListener('dragover', function (event) {
                //阻止默认事件
                event.preventDefault();
                //阻止冒泡
                event.stopPropagation();
                //返回状态码
                ClassThis.options.OPState(1);
            });
            // 在拖动的元素进入到放置目标时执行
            ClassThis.DElement.addEventListener('dragenter', function (event) {
                //阻止默认事件
                event.preventDefault();
                //阻止冒泡
                event.stopPropagation();
                //返回状态码
                ClassThis.options.OPState(3);
            });
            // 在可拖动的元素移出放置目标时执行
            ClassThis.DElement.addEventListener('dragleave', function (event) {
                //阻止默认事件
                event.preventDefault();
                //阻止冒泡
                event.stopPropagation();
                //返回状态码
                ClassThis.options.OPState(4);
            });
            // 在可拖动元素（文件）放置在目标元素中时执行
            ClassThis.DElement.addEventListener('drop', function (event) {
                //阻止默认事件
                event.preventDefault();
                //阻止冒泡
                event.stopPropagation();
                //返回状态码
                ClassThis.options.OPState(5);
                // 调用文件(文件夹)处理函数,为了判断是否为文件夹，所以放到后面处理了，这里用null代替files（即为空值）
                ClassThis.FileHandleFun(event, null, ClassThis);
            });
        }

        //文件(文件夹)处理函数
        async FileHandleFun(event, files, ClassThis) {
            //读取文件夹时，如果有多层文件夹就会同时文件数量超出限制时
            //会造成多次返回状态码，因此用One配合解决
            let One = true;

            if (event.type === 'drop') {

                files = event.dataTransfer;
                let filesCount = 0;
                // 遍历所提交的文件夹
                for (var item of files.items) {
                    // 获取到的每一个文件夹自带的方法，用于获取对应的内容
                    item = item.webkitGetAsEntry();
                    if (item.isDirectory) { //判断是否为文件夹
                        //如果为文件夹，且为火狐浏览器
                        // if (navigator.userAgent.indexOf("Firefox") > 0) {
                        //     console.warn('火狐浏览器暂时不支持提交文件夹');
                        //     //返回状态码
                        //     ClassThis.options.OPState(9);
                        //     return null;
                        // }
                        //获取文件并调用文件函数
                        //console.log("文件夹");
                        FolderFun(files, item);
                    } else if (item.isFile) { //判断是否为文件
                        //console.log("文件");
                        //遍历到最后一次才调用
                        if (filesCount === files.items.length - 1) {
                            //获取文件并调用文件函数
                            FileFun(files.files, ClassThis);
                        }
                        filesCount++;
                    }
                }
            } else {
                //调用文件函数
                FileFun(files, ClassThis);
            }

            function checkExentensioname(item, ClassThis) {
				//不检查 后缀名 
				return true;
                var namearr = item.name.split('.');
                var namelength = namearr.length;
                // console.warn('3334', namearr);
                // console.warn('3334', namelength);
                // console.warn('3334:后缀名:', namearr[namelength-1]);
                if (namelength < 2) {
                    //没有后缀名
                    return false;
                } else {
                    //return namearr[namelength-1].toLowerCase();

                    if (!DropFormCheck || ClassThis.options.FormatList.includes(namearr[namelength - 1].toLowerCase())) {
                        return true;
                    } else {
                        false;
                    }
                }
            }

            //文件函数
            function FileFun(files, ClassThis) {
                //返回状态码
                ClassThis.options.OPState(8);
                for (var item of files) {
                    //判断格式是否为空

                    //if (!DropFormCheck || item.type.replace(/(\s)/g, "")) {
                    // 判断格式是否符合要求

                    //if (!DropFormCheck || ClassThis.options.FormatList.includes(item.type.split('/')[1].toLowerCase())) {
                    if (checkExentensioname(item, ClassThis)) {
                        //判断数量限制是否有填或者文件数量是否小于限制数量
                        if (ClassThis.options.QuantityLimit === null || (Object.keys(getResult[
                            'UploadList']).length +
                            Object.keys(TemporaryList).length) < ClassThis.options.QuantityLimit) {
                            //将File对象添加进文件列表
                            TemporaryList[Object.keys(TemporaryList).length] = {
                                "FileName": item.name,
                                "FileRoute": item.name,
                                "File": item,
                                "SubmitTime": new Date().getTime()
                            };
                            //返回状态码
                            ClassThis.options.OPState(11);
                        } else {
                            //调用输出警告函数
                            ClassThis.init.OutputWarning(ClassThis,
                                `文件限制上传${ClassThis.options.QuantityLimit}个，已超出限制`);
                            //返回状态码
                            ClassThis.options.OPState(10);
                            return null;
                        }
                    } else {
                        //调用输出警告函数
                        ClassThis.init.OutputWarning(ClassThis,
                            `文件：${item.name}不符合要求`
                        );

                        //DropFileFirstFlag
                        ErrorList[Object.keys(ErrorList).length] = {
                            "FileName": item.name,
                            "FileRoute": item.name,
                            "File": item,
                            "SubmitTime": new Date().getTime()
                        };
                    }
                    //} else {
                    //调用输出警告函数
                    //ClassThis.init.OutputWarning(ClassThis, `文件：${item.name.split('.')[0]}的格式为空，不符合要求`);
                    //}
                }
                //if (Object.keys(TemporaryList).length !== 0) {
                //调用ToolFun函数
                //ClassThis.ToolFun(ClassThis, null);
                //}

                ClassThis.ToolFun(ClassThis, null);
            }

            //文件夹函数async
            async function FolderFun(files, item) {
                if (item.isDirectory) { //如果是文件夹
                    //读取文件夹
                    //console.log("FolderFun文件夹");
                    let directoryReader = item.createReader();
                    let countnum = 1;
                    let res = [];
                    let directoryEntrieList = await read();
                    async function read() {
                        const fileEntries = await new Promise((resolve, reject) =>
                            directoryReader.readEntries((entries) => {
                                Promise.all(entries).then(resolve)
                            }, reject)
                        )
                        // 保存当前读取文件
                        res = [...res, ...fileEntries]
                        // chrome浏览器一次读取最多获取100个文件，多于100个需要再次读取
                        if (fileEntries.length < 100) {
                            return res;
                        }
                        return read();
                    }

                    directoryEntrieList.forEach(function (entry) {
                        // 再次调用FolderFun函数
                        //console.log("遍历文件夹FolderFun文件",countnum,entry);
                        countnum++;
                        FolderFun(files, entry);
                    });


                } else if (item.isFile) { //如果是文件
                    //返回状态码
                    //console.log("FolderFun文件");
                    ClassThis.options.OPState(8);
                    //调用提取函数将文件取出（将FileEntry转为File）
                    let resFile = await ExtractFile(item);

                    //判断格式是否为空
                    //if (!DropFormCheck || resFile.type.replace(/(\s)/g, "")) {
                    // 判断格式是否符合要求
                    // console.log("type:", item.type);
                    //if (!DropFormCheck || ClassThis.options.FormatList.includes(resFile.type.split('/')[1]
                    // .toLowerCase())) {
                    if (checkExentensioname(item, ClassThis)) {
                        //判断数量限制是否有填或者文件数量是否小于限制数量
                        if (ClassThis.options.QuantityLimit === null || ((Object.keys(getResult[
                            'UploadList'])
                            .length + Object.keys(TemporaryList).length) < ClassThis.options
                                .QuantityLimit)) {
                            //将File对象添加进文件列表或者文件数量是否小于限制数量
                            TemporaryList[Object.keys(TemporaryList).length] = {
                                "FileName": item.name,
                                "FileRoute": item.fullPath,
                                "File": resFile,
                                "SubmitTime": new Date().getTime()
                            };
                            //console.log("TemporaryList:",TemporaryList[Object.keys(TemporaryList).length-1]);
                            //返回状态码
                            ClassThis.options.OPState(11);
                            //文件数量等于限制数量则调用ToolFun函数
                            if ((Object.keys(getResult['UploadList']).length + Object.keys(
                                TemporaryList).length) ===
                                ClassThis.options.QuantityLimit) {
                                //防止在调用函数之后再次被调用
                                clearTimeout(ClearSetTimeout);
                                ClassThis.ToolFun(ClassThis, null);
                                return null;
                            } else {
                                //在下一个File对象创建完成时删除定时器
                                //与定时器配合，保障不会过多或不正常的调用ToolFun函数
                                clearTimeout(ClearSetTimeout);
                                ClearSetTimeout = setTimeout(function () {
                                    if (Object.keys(TemporaryList).length !== 0) {
                                        //调用ToolFun函数
                                        ClassThis.ToolFun(ClassThis, null);
                                    }
                                }, 500);
                                return null;
                            }
                        } else {
                            if (One === true) {
                                //调用输出警告函数
                                ClassThis.init.OutputWarning(ClassThis,
                                    `文件限制上传${ClassThis.options.QuantityLimit}个，已超出限制`);
                                //返回状态码
                                ClassThis.options.OPState(10);
                                One = false;
                                return null;
                            }
                        }
                    } else {
                        //调用输出警告函数
                        ClassThis.init.OutputWarning(ClassThis,
                            `文件：${resFile.name}不符合要求`
                        );
                        //DropFileFirstFlag
                        ErrorList[Object.keys(ErrorList).length] = {
                            "FileName": item.name,
                            "FileRoute": item.name,
                            "File": item,
                            "SubmitTime": new Date().getTime()
                        };
                    }
                    //} else {
                    //调用输出警告函数
                    //ClassThis.init.OutputWarning(ClassThis,
                    //`文件：${resFile.name.split('.')[0]}的格式为空，不符合要求`);
                    //}
                    //await：返回 Promise 对象的处理结果。如果等待的不是 Promise 对象，则返回该值本身
                    //await：操作符用于等待一个Promise 对象。它只能在异步函数 async function 中使用。
                }
                //提取函数
                function ExtractFile(item) {
                    //创建Promise对象后进一步创建File对象
                    return new Promise((resolve, reject) => {
                        item.file(res => {
                            resolve(res);
                        });
                    });
                }
            }
        }


        ToolFun(ClassThis, DeleteState) {
            //说明返回类型
            getResult['ResultType'] = '部分结果';

            //清理返回列表
            Object.keys(getResult['AttributeList']).forEach(function (key) {
                delete getResult['AttributeList'][key];
            });

            Object.keys(TemporaryList).forEach(function (key) {
                //火狐没有lastModifiedDate,所以需要赋值
                if (!TemporaryList[key]['File'].lastModifiedDate) {
                    TemporaryList[key]['File'].lastModifiedDate = new Date(TemporaryList[key]['File']
                        .lastModified);
                }

                //将文件列表赋值给上传列表
                //getResult['UploadList'][Object.keys(getResult['UploadList']).length] = TemporaryList[
                //key];

                //let PreviewFileO = '不支持该文件类型预览',
                //PreviewFileT = '不支持该文件类型预览';



                //提取文件具体信息赋值给返回列表
                //getResult['AttributeList'][Object.keys(getResult['AttributeList']).length] = {
                //文件名
                //FileName: TemporaryList[key]['File'].name,
                //文件格式
                //FileFormat: TemporaryList[key]['File'].type.toLowerCase(),
                //文件大小
                //FileSize: Math.round(TemporaryList[key]['File'].size * 100 / 1024) / 100 + 'KB',
                //格式化的修改时间
                //TormatTime: TemporaryList[key]['File'].lastModifiedDate.toLocaleDateString() +
                //' ' +
                //TemporaryList[key]['File'].lastModifiedDate
                //.toTimeString().split(' ')[0],

                //时间戳
                //TimeDate: TemporaryList[key]['SubmitTime'],
                //文件路径
                //FileRoute: TemporaryList[key]['FileRoute'],
                //window.URL.createObjectURL(TemporaryList[key]['File'])方式预览文件
                //PreviewFileWin: PreviewFileO,
                //FileReader方式预览文件
                //PreviewFileFR: PreviewFileT,

                // lastModified: TemporaryList[key]['File'].lastModified,
                // lastModifiedDate: TemporaryList[key]['File'].lastModifiedDate,
                // name: TemporaryList[key]['File'].name,
                // size: TemporaryList[key]['File'].size,
                // type: TemporaryList[key]['File'].type.toLowerCase()

                //}
                TemporaryList[key]['File']["FileRoute"] = TemporaryList[key]['FileRoute'];
                getResult['AttributeList'][Object.keys(getResult['AttributeList']).length] = TemporaryList[key]['File']

                delete TemporaryList[key];
            });

            getResult["AttributeArray"] = Object.keys(getResult['AttributeList']).map(function (i) { return getResult['AttributeList'][i] }); //对象转化为数组


            Object.keys(ErrorList).forEach(function (key) {
                //火狐没有lastModifiedDate,所以需要赋值
                if (!ErrorList[key]['File'].lastModifiedDate) {
                    ErrorList[key]['File'].lastModifiedDate = new Date(ErrorList[key]['File']
                        .lastModified);
                }

                getResult['ErrorList'][Object.keys(getResult['ErrorList']).length] = ErrorList[key]['File']

                delete ErrorList[key];
            });
            //判断是否有传入DeleteState
            // if (DeleteState !== null && DeleteState !== undefined) {
            //     //判断是否有传入DeleteState['DeleteOPState']
            //     if (DeleteState['DeleteOPState'] !== null && DeleteState['DeleteOPState'] !== undefined) {
            //         //判断DeleteState['DeleteOPState']是否为函数
            //         if (typeof DeleteState['DeleteOPState'] === 'function') {
            //             //返回状态码
            //             DeleteState['DeleteOPState'](12);
            //         }
            //     }
            //     //判断是否有传入DeleteState['DeleteResultSet']
            //     if (DeleteState['DeleteResultSet'] !== null && DeleteState['DeleteResultSet'] !== undefined) {
            //         //判断DeleteState['DeleteResultSet']是否为函数
            //         if (typeof DeleteState['DeleteResultSet'] === 'function') {
            //             //返回信息
            //             DeleteState['DeleteResultSet'](getResult);
            //         }
            //     }
            // } else {
            //     //判断“提交”一类按钮存不存在
            //     if (this.ReturnButtom === false) {
            //         //如果提交按钮不存在就调用
            //         ClassThis.ReturnFun(ClassThis);
            //     } else {
            //         //如果提交按钮存在，返回部分结果用于预览
            //         ClassThis.options.ResultSet(getResult);
            //     }
            // }

            //如果提交按钮不存在就调用
            ClassThis.ReturnFun(ClassThis);
        }



        //返回函数
        ReturnFun(ClassThis) {
            getResult['WholeSize'] = 0;
            //说明返回类型
            getResult['ResultType'] = '全部结果';
            getResult['WholeformData'] = new FormData();
            getResult['WholeformData'].forEach(function (key) {
                getResult['WholeformData'].delete(key);
            });
            Object.keys(getResult['UploadList']).forEach(function (key) {
                getResult['UploadList'][key]['formData'] = new FormData();
                getResult['UploadList'][key]['formData'].delete("File");
                getResult['UploadList'][key]['formData'].append("File", getResult['UploadList'][key][
                    'File'
                ]);
                getResult['WholeformData'].append("File", getResult['UploadList'][key]['File']);
                getResult['WholeSize'] += getResult['UploadList'][key]['File']['size'];
            });

            //返回信息
            ClassThis.options.ResultSet(getResult);
        }
    }

    const FileUpload = (DPObject) => {
        const DPObjectArray = ['ClickElement', 'DragElement', 'OPPattern', 'ReturnButtom', 'QuantityLimit',
            'ConsoleAutograph', 'FormatList', 'OutputWarning', 'OPState', 'ResultSet'
        ];

        Object.keys(DPObject).forEach(function (key) {
            if (!DPObjectArray.includes(key)) {
                throw new Error('不接受其规定以外的属性');
            }
            if (key === 'OPState') {
                //判断DPObject.OPState的类型是否为函数
                if (typeof DPObject.OPState !== 'function') {
                    //删除之后在拼合之后也会缺失
                    // delete DPObject.OPState;
                    DPObject.OPState = FileUploadDP['OPState'];
                }
            }
            if (key === 'ResultSet') {
                //判断DPObject.ResultSet的类型是否为函数
                if (typeof DPObject.ResultSet !== 'function') {
                    //删除之后在拼合之后也会缺失
                    // delete DPObject.OPState;
                    DPObject.ResultSet = FileUploadDP['ResultSet'];
                }
            }
        });

        //实例化Class
        const FileUploadHandle = new FileUploadClass();
        //FileUpload.DeleteFun = (data) => FileUploadHandle.DeleteFun(data);

        const {
            ClickElement,
            DragElement,
            OPPattern,
            Delete,
            ReturnButtom
        } = DPObject;
        const DPObjectItme = {
            ClickElement,
            DragElement,
            OPPattern,
            Delete,
            ReturnButtom
        };
        Object.keys(DPObjectItme).forEach(function (key) {
            if (DPObjectItme[key] !== null && DPObjectItme[key] !== undefined) {
                if (typeof DPObjectItme[key] !== 'string') {
                    throw new Error(`${key}属性值的类型必须为string`);
                }
            }
        });
        //先判断文件格式列表是否符合规则，不符合则没必要进行下去
        if (DPObject.FormatList) {
            if (typeof DPObject.FormatList !== 'object') {
                if (DPObject.FormatList.replace(/(\s)/g, "")) {
                    throw new Error('文件格式列表类型必须为数组');
                } else {
                    throw new Error('文件格式列表不能为空');
                }
            } else {
                DPObject.FormatList.forEach(function (item, index, self) {
                    if (typeof DPObject.FormatList[index] === 'string') {
                        DPObject.FormatList[index] = item.replace(/(\s)/g, "").toLowerCase();
                    } else {
                        throw new Error('文件格式类型必须为string');
                    }
                });
            }
        } else {
            throw new Error('文件格式列表不能为空');
        }

        if (DPObject.QuantityLimit) {
            if (typeof DPObject.QuantityLimit === 'number' || typeof DPObject.QuantityLimit === 'string') {
                if (parseInt(DPObject.QuantityLimit)) {
                    DPObject.QuantityLimit = parseInt(DPObject.QuantityLimit);
                } else {
                    throw new Error('属性为字符串类型且无法转为数字类型');
                }
            } else {
                throw new Error('类型不正确');
            }
        }

        if (DPObject.OPPattern) { //如果DPObject.OPPattern存在且不为空
            if (DPObject.OPPattern.replace(/(\s)/g, "")) {
                DPObject.OPPattern = DPObject.OPPattern.replace(/(\s)/g, "").toLowerCase();
                if (DPObject.OPPattern === 'drag' || DPObject.OPPattern ===
                    'dragandclick') {
                    if (DPObject.OPPattern === 'drag') {
                        DPObject.DragElement = DPObject.DragElement.replace(/(\s)/g, "");
                        if (DPObject.DragElement) {
                            if (DPObject.DragElement.replace(/(\s)/g, "")) {
                                const DragElement = document.querySelector(DPObject.DragElement);
                                if (DragElement) {
                                    //调用Class中的init函数
                                    FileUploadHandle.init(DPObject);
                                } else {
                                    throw new Error('接受拖拽结果的元素传入错误');
                                }
                            } else {
                                throw new Error('接受拖拽结果的元素不能为空');
                            }
                        } else {
                            throw new Error('接受拖拽结果的元素不能为空');
                        }
                        return null;
                    }

                    if (DPObject.OPPattern === 'dragandclick') {
                        if (DPObject.DragElement) {
                            DPObject.DragElement = DPObject.DragElement.replace(/(\s)/g, "");

                            if (DPObject.DragElement.replace(/(\s)/g, "")) {
                                const DragElement = document.querySelector(DPObject.DragElement);

                                if (DragElement) {
                                    //调用Class中的init函数
                                    FileUploadHandle.init(DPObject);
                                } else {
                                    throw new Error('接受拖拽结果的元素传入错误');
                                }
                            } else {
                                throw new Error('接受拖拽结果的元素都不能为空');
                            }
                        } else {
                            throw new Error('接受拖拽结果的元素都不能为空');
                        }
                        return null;
                    }
                } else {
                    throw new Error('操作模式只能为：drag、dragandclick其中一种');
                }
            } else {
                throw new Error('操作模式不能为空');
            }
        } else {
            throw new Error('操作模式不能为空');
        }
    }
    event.FileUpload = FileUpload;
})(window);